diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 128849c9c..9727b497e 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -2,6 +2,8 @@ package net.minecraft.client.player.controller;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.render.RenderGlobal;
 import net.minecraft.core.InventoryAction;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicDoor;
@@ -16,359 +18,385 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
+import java.util.Objects;
+
 import static net.minecraft.core.world.LevelListener.EVENT_BLOCK_BREAK;
 
 public abstract class PlayerController {
-	
-	protected float currentDamage;
-	protected float previousDamage;
-	protected int soundDelay;
-	protected int swingCooldown = 0;
-	protected int blockHitDelay;
-	protected Integer miningX, miningY, miningZ;
-
-	protected final Minecraft mc;
-
-	public PlayerController(Minecraft minecraft) {
-		mc = minecraft;
-	}
-	
-	//Called when the mouse is clicked and about 5 times per second while the button is held down
-	//Repeat is false when the mouse was clicked this frame
-	public void startDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit, boolean repeat) {
-		if (mc.thePlayer.getHeldObject() != null) return;
-		if (!mc.thePlayer.getGamemode().canInteract()) return;
-		if(!mc.thePlayer.getGamemode().hasBlockBreakingAnimation()) {
-			swingItem(true);
-			
-			ItemStack heldItem = mc.thePlayer.getCurrentEquippedItem();
-			if(heldItem != null && heldItem.getItem().hasTag(ItemTags.PREVENT_CREATIVE_MINING)) {
-				return;
-			}
-			
-			destroyBlock(x, y, z, side, mc.thePlayer);
-			sendStartDigPacket(x, y, z, side, xHit, yHit);
-			return;
-		}
-
-		Block<?> mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
-		if(mineBlock != null) {
-			float mineStrength = mineBlock.blockStrength(mc.currentWorld, x, y, z, side, mc.thePlayer);
-			
-			if(mineStrength < 1.0f) {
-				if(!repeat) {
-					sendStartDigPacket(x, y, z, side, xHit, yHit);
-					hitBlock(x, y, z, side, xHit, yHit);
-					setMineBlock(x, y, z);
-				}
-			}
-		}
-	}
-	
-	//Called 20 times per second when the mouse button is held and blocks are targeted
-	public void continueDestroyBlock(int x, int y, int z, Side side, double xHit, double yHit) {
-		if(!mc.thePlayer.getGamemode().hasBlockBreakingAnimation() || !mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) {
-			return;
-		}
-		
-		swingItem(false);
-		
-		if(blockHitDelay > 0) {
-			blockHitDelay--;
-			return;
-		}
-		
-		Block<?> mineBlock = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
-		if(mineBlock != null) {	
-			syncCurrentPlayItem();
-			
-			float mineStrength = mineBlock.blockStrength(mc.currentWorld, x, y, z, side, mc.thePlayer);
-			if(mineStrength >= 1.0f) {
-				//Instant Mining
-				
-				setMineBlock(x, y, z);
-				destroyBlock(x, y, z, side, mc.thePlayer);
-				//Start Dig Packet acts as block destroy packet when instantmining
-				sendStartDigPacket(x, y, z, side, xHit, yHit);
-				
-				currentDamage = 0.0f;
-				previousDamage = 0.0f;
-				soundDelay = 0;
-				blockHitDelay = 1;
-			}else {
-				//Regular Mining
-				
-				if(!isMiningBlock(x, y, z)) {
-					sendStartDigPacket(x, y, z, side, xHit, yHit);
-					if (mc.currentWorld.getBlockLogic(x, y, z, BlockLogicDoor.class) == null) { // "Fixes" issue where at certain angles you can spam hit the top and bottom blocks of the door.
-						hitBlock(x, y, z, side, xHit, yHit);
-					}
-					currentDamage = 0.0f;
-					previousDamage = 0.0f;
-					setMineBlock(x, y, z);
-				}
-				
-				mc.particleEngine.crack(x, y, z, side);
-				playDigSound(mineBlock, x, y, z);
-				 
-				currentDamage += mineStrength;
-				if(currentDamage > 1.0f) {
-					destroyBlock(x, y, z, side, mc.thePlayer);
-					sendDestroyBlockPacket(x, y, z, side, xHit, yHit);
-					setMineBlock(null, null, null);
-					currentDamage = 0.0f;
-					previousDamage = 0.0f;
-					soundDelay = 0;
-					
-					int newBlockHitDelay;
-					if(mineStrength > 0.5f) {
-						newBlockHitDelay = 2;
-					}else if(mineStrength > 0.4f) {
-						newBlockHitDelay = 3;
-					}else if(mineStrength > 0.3f) {
-						newBlockHitDelay = 4;
-					}else {
-						newBlockHitDelay = 5;
-					}
-					
-					blockHitDelay = newBlockHitDelay;
-				}
-			}
-			
-		}else {
-			currentDamage = 0.0f;
-			previousDamage = 0.0f;
-			soundDelay = 0;
-		}
-	}
-	
-	public boolean swingItem(boolean force) {
-		if(swingCooldown == 0 || force) {
-			mc.thePlayer.swingItem();
-			swingCooldown = 5;
-			return true;
-		}
-		return false;
-	}
-
-	public boolean destroyBlock(int x, int y, int z, @NotNull Side side, @NotNull Player player) {
-		if (!player.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return false;
-		setMineBlock(null, null, null);
-		World world = mc.currentWorld;
-		Block<?> block = Blocks.getBlock(world.getBlockId(x, y, z));
-		if(block == null) return false;
-		
-		Item heldItem = null;
-		ItemStack heldItemStack = player.getCurrentEquippedItem();
-		if(heldItemStack != null) {
-			if(!heldItemStack.beforeDestroyBlock(world, block.id(), x, y, z, side, player)) {
-				return false;
-			}
-			heldItem = heldItemStack.getItem();
-		}
-		
-		world.playBlockEvent(EVENT_BLOCK_BREAK, x, y, z, block.id());
-		int meta = world.getBlockMetadata(x, y, z);
-		boolean removed = world.setBlockWithNotify(x, y, z, 0);
-		if(removed) {
-			block.onBlockDestroyedByPlayer(world, x, y, z, side, meta, player, heldItem);
-		}
-		return removed;
-	}
-
-	public void stopDestroyBlock(boolean leftClickDown) {
-		currentDamage = 0.0F;
-		previousDamage = 0.0f;
-		soundDelay = 0;
-		
-		if(blockHitDelay > 0) {
-			blockHitDelay--;
-		}
-	}
-	
-	protected void hitBlock(int x, int y, int z, Side side, double xHit, double yHit) {
-		if (!mc.thePlayer.getGamemode().canInteract() || mc.thePlayer.getHeldObject() != null) return;
-		mc.currentWorld.onBlockHit(mc.thePlayer, x, y, z, side);
-		
-		Block<?> block = Blocks.getBlock(mc.currentWorld.getBlockId(x, y, z));
-		if(block != null) {
-			block.onBlockLeftClicked(mc.currentWorld, x, y, z, mc.thePlayer, side, xHit, yHit);
-		}
-	}
-	
-	private boolean isMiningBlock(int x, int y, int z) {
-		return miningX != null && miningX == x && miningY != null && miningY == y && miningZ != null && miningZ == z;
-	}
-	
-	private void setMineBlock(Integer x, Integer y, Integer z) {
-		this.miningX = x;
-		this.miningY = y;
-		this.miningZ = z;
-	}
-
-	public void render(float f) {
-		if (currentDamage <= 0.0F) {
-			mc.hudIngame.damageGuiPartialTime = 0.0F;
-			mc.renderGlobal.destroyProgress = 0.0F;
-		} else {
-			float f1 = previousDamage + (currentDamage - previousDamage) * f;
-			mc.hudIngame.damageGuiPartialTime = f1;
-			mc.renderGlobal.destroyProgress = f1;
-		}
-
-        mc.ppm.render(f);
+
+    protected final @NotNull Minecraft mc;
+
+    protected float destroyProgress;
+    protected float oDestroyProgress;
+    protected int soundDelay;
+    protected int swingCooldown = 0;
+    protected int destroyDelay;
+    protected @Nullable TilePosc mining;
+
+    public PlayerController(final @NotNull Minecraft minecraft) {
+        this.mc = minecraft;
+    }
+
+    /**
+     * Called when the mouse is clicked and about 5 times per second while the button is held down.
+     * <br>
+     * {@code repeat} is false when the mouse was clicked this frame.
+     */
+    public void startDestroyBlock(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit, final boolean repeat) {
+        final @NotNull World world = Objects.requireNonNull(this.mc.currentWorld);
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+
+        if (player.getHeldObject() != null || !player.getGamemode().canInteract()) {
+            return;
+        }
+
+        if (!player.getGamemode().hasBlockBreakingAnimation()) {
+            this.swingItem(true);
+
+            final @Nullable ItemStack heldItem = player.getCurrentEquippedItem();
+            if (heldItem != null && heldItem.getItem().hasTag(ItemTags.PREVENT_CREATIVE_MINING)) {
+                return;
+            }
+
+            this.destroyBlock(tilePos, side);
+            this.sendStartDigPacket(tilePos, side, xHit, yHit);
+            return;
+        }
+
+        final @NotNull Block<?> mineBlock = world.getBlockType(tilePos);
+        final float mineStrength = mineBlock.getStrength(world, tilePos, side, player);
+
+        if (mineStrength < 1.0f) {
+            if (!repeat) {
+                this.sendStartDigPacket(tilePos, side, xHit, yHit);
+                this.hitBlock(tilePos, side, xHit, yHit);
+                this.setMineBlock(tilePos);
+            }
+        }
+    }
+
+    //Called 20 times per second when the mouse button is held and blocks are targeted
+    public void continueDestroyBlock(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        final @NotNull World world = Objects.requireNonNull(this.mc.currentWorld);
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+
+        if (!player.getGamemode().hasBlockBreakingAnimation() || !player.getGamemode().canInteract() || player.getHeldObject() != null) {
+            return;
+        }
+
+        this.swingItem(false);
+
+        if (this.destroyDelay > 0) {
+            this.destroyDelay--;
+            return;
+        }
+
+        final Block<?> mineBlock = world.getBlockType(tilePos);
+        this.syncCurrentPlayItem();
+
+        final float mineStrength = mineBlock.getStrength(world, tilePos, side, player);
+        if (mineStrength >= 1.0f) {
+            //Instant Mining
+            this.setMineBlock(tilePos);
+            this.destroyBlock(tilePos, side);
+
+            //Start Dig Packet acts as block destroy packet when instantmining
+            this.sendStartDigPacket(tilePos, side, xHit, yHit);
+
+            this.destroyProgress = 0.0f;
+            this.oDestroyProgress = 0.0f;
+            this.soundDelay = 0;
+            this.destroyDelay = 1;
+        } else {
+            //Regular Mining
+            if (!this.isMiningBlock(tilePos)) {
+                this.sendStartDigPacket(tilePos, side, xHit, yHit);
+                if (world.getBlockLogic(tilePos, BlockLogicDoor.class) == null) { // "Fixes" issue where at certain angles you can spam hit the top and bottom blocks of the door.
+                    this.hitBlock(tilePos, side, xHit, yHit);
+                }
+                this.destroyProgress = 0.0f;
+                this.oDestroyProgress = 0.0f;
+                this.setMineBlock(tilePos);
+            }
+
+            Objects.requireNonNull(this.mc.particleEngine).crack(tilePos.x(), tilePos.y(), tilePos.z(), side);
+            this.playDigSound(mineBlock, tilePos);
+
+            this.destroyProgress += mineStrength;
+            if (this.destroyProgress > 1.0f) {
+                this.destroyBlock(tilePos, side);
+                this.sendDestroyBlockPacket(tilePos, side, xHit, yHit);
+                this.setMineBlock(null);
+                this.destroyProgress = 0.0f;
+                this.oDestroyProgress = 0.0f;
+                this.soundDelay = 0;
+
+                final int newDestroyDelay;
+                if (mineStrength > 0.5f) {
+                    newDestroyDelay = 2;
+                } else if (mineStrength > 0.4f) {
+                    newDestroyDelay = 3;
+                } else if (mineStrength > 0.3f) {
+                    newDestroyDelay = 4;
+                } else {
+                    newDestroyDelay = 5;
+                }
+
+                this.destroyDelay = newDestroyDelay;
+            }
+        }
+
+    }
+
+    public boolean swingItem(final boolean force) {
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+
+        if (this.swingCooldown == 0 || force) {
+            player.swingItem();
+            this.swingCooldown = 5;
+            return true;
+        }
+
+        return false;
+    }
+
+    public boolean destroyBlock(final @NotNull TilePosc tilePos, final @NotNull Side side) {
+        final @NotNull World world = Objects.requireNonNull(this.mc.currentWorld);
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+
+        if (!player.getGamemode().canInteract() || player.getHeldObject() != null) {
+            return false;
+        }
+
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        final int data = world.getBlockData(tilePos);
+
+        this.setMineBlock(null);
+
+        @Nullable Item heldItem = null;
+        final @Nullable ItemStack heldItemStack = player.getCurrentEquippedItem();
+        if (heldItemStack != null) {
+            if (!heldItemStack.beforeBlockDestroyed(world, player, block, tilePos, side)) {
+                return false;
+            }
+            heldItem = heldItemStack.getItem();
+        }
+
+        world.playBlockEvent(tilePos, EVENT_BLOCK_BREAK, block.id());
+
+        if (world.setBlockTypeNotify(tilePos, Blocks.AIR)) {
+            block.onDestroyedByPlayer(world, tilePos, side, data, player, heldItem);
+            return true;
+        }
+
+        return false;
+    }
+
+    public void stopDestroyBlock() {
+        this.destroyProgress = 0.0F;
+        this.oDestroyProgress = 0.0f;
+        this.soundDelay = 0;
+
+        if (this.destroyDelay > 0) {
+            this.destroyDelay--;
+        }
     }
 
-	public float getBlockReachDistance() {
-		return mc.thePlayer.getGamemode().getBlockReachDistance();
-	}
-
-	public float getEntityReachDistance() {
-		return mc.thePlayer.getGamemode().getEntityReachDistance();
-	}
-
-	public void initPlayer(Player player) {
-		player.yRot = -180F;
-	}
-
-	public void tick() {
-		if(swingCooldown > 0) swingCooldown--;
-		
-		syncCurrentPlayItem();
-		previousDamage = currentDamage;
-		mc.sndManager.tick();
-		mc.ppm.tick();
-	}
-
-	public boolean canHurtPlayer() {
-		return true;
-	}
-
-	public void adjustPlayer(Player player) {
-	}
-
-	/**
-	 * Used to dynamically use or place an ItemStack on any given tile.
-	 * <p>
-	 * (i.e. interacting with a chest while holding a block, defaulting to opening the chest when standing, vs. placing the block when crouched)
-	 */
-	public boolean useOrPlaceItemStackOnTile(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced)
-	{
-		if (!player.getGamemode().canInteract()) return false;
-		int blockId = world.getBlockId(blockX, blockY, blockZ);
-		if (player.getHeldObject() == null) {
-			if (player.isSneaking() && itemstack == null) { // If crouched and hand empty try to pickup block entity
-				TileEntity tileEntity = world.getTileEntity(blockX, blockY, blockZ);
-				if (tileEntity != null && tileEntity.canBeCarried(world, player)) {
-					player.setHeldObject(tileEntity.pickup(world, player));
-					return true;
-				}
-			}
-			if (!player.isSneaking() || itemstack == null) {  // If standing or hand empty perform block right click method
-				if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
-					return true;
-				}
-			}
-			if (itemstack == null) { // No stack then do nothing
-				return false;
-			} else { // Use itemstack
-				return itemstack.useItem(player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-			}
-		} else {
-			if (!player.isSneaking()) {  // If standing or hand empty perform block right click method
-				if (blockId > 0 && Blocks.blocksList[blockId].onBlockRightClicked(world, blockX, blockY, blockZ, player, side, xPlaced, yPlaced)) {
-					return true;
-				}
-			}
-			boolean didPlace = player.getHeldObject().tryPlace(world, player, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-			if (didPlace) {
-				player.setHeldObject(null);
-			}
-			return didPlace;
-		}
-	}
-
-	/**
-	 * Used to specifically use an ItemStack on nothing, most commonly defaulting to typical "item use" behavior.
-	 * <p>
-	 * (i.e. throwing a fishing rod or shooting a bow)
-	 */
-	public boolean useItemStackOnNothing(Player player, World world, ItemStack stack) {
-		if (!player.getGamemode().canInteract()) return false;
-		int prevStackSize = stack.stackSize;
-		ItemStack newItemStack = stack.useItemRightClick(world, player);
-		if(newItemStack != stack || newItemStack.stackSize != prevStackSize) {
-			player.inventory.mainInventory[player.inventory.getCurrentSlot()] = newItemStack;
-			if(newItemStack == null || newItemStack.stackSize <= 0) {
-				player.inventory.mainInventory[player.inventory.getCurrentSlot()] = null;
-			}
-			return true;
-		}
-		return false;
-	}
-
-	/**
-	 * Used to exclusively place an ItemStack. No interactions, just placing a held ItemStack.
-	 * <p>
-	 * (i.e. placing blocks using easy bridge)
-	 */
-	public boolean placeItemStackOnTile(@NotNull Player player, @NotNull World world, @Nullable ItemStack itemstack, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-		if (!player.getGamemode().canInteract()) return false;
-		if (player.getHeldObject() == null) {
-			if (itemstack == null) { // No stack then do nothing
-				return false;
-			} else { // Use itemstack
-				return itemstack.useItem(player, world, blockX, blockY, blockZ, side, xPlaced, yPlaced);
-			}
-		}
-		return false;
-	}
-
-	public Player createPlayer(World world) {
-		return new PlayerLocal(mc, world, mc.session, world.dimension.id);
-	}
-
-	public boolean interact(Player player, Entity entity) {
-		if (!player.getGamemode().canInteract()) return false;
-		return player.useCurrentItemOnEntity(entity);
-	}
-
-	public void attack(@NotNull Player player, @NotNull Entity entity) {
-		if (!player.getGamemode().canInteract()) return;
-		player.attackTargetEntityWithCurrentItem(entity);
-	}
-
-	public ItemStack handleInventoryMouseClick(int windowId, InventoryAction action, int[] args, Player player) {
-		return player.craftingInventory.clicked(action, args, player);
-	}
-
-	public void handleCloseInventory(int i, Player player) {
-		player.craftingInventory.onCraftGuiClosed(player);
-		player.craftingInventory = player.inventorySlots;
-	}
-	
-	public void playDigSound(Block<?> block, int x, int y, int z) {
-		if(soundDelay <= 0) {
-			mc.currentWorld.playBlockSoundEffect(null, x + 0.5f, y + 0.5f, z + 0.5f, block, EnumBlockSoundEffectType.DIG);
-			soundDelay = 3;
-		}else {
-			soundDelay--;
-		}
-	}
-
-	protected void syncCurrentPlayItem() {}
-	
-	public void sendStartDigPacket(int x, int y, int z, Side side, double xHit, double yHit) {}
-	
-	public void sendDestroyBlockPacket(int x, int y, int z, Side side, double xHit, double yHit) {}
-
-	public void initWorld(World world) {}
-
-	public void setPaintingType(ArtType art)
-	{
-		mc.thePlayer.setSelectedArt(art);
-	}
+    protected void hitBlock(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        final @NotNull World world = Objects.requireNonNull(this.mc.currentWorld);
+        final @NotNull Player player = Objects.requireNonNull(this.mc.thePlayer);
+
+        if (!player.getGamemode().canInteract() || player.getHeldObject() != null) {
+            return;
+        }
+
+        world.onBlockHit(player, tilePos, side);
+
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+        block.onAttacked(world, tilePos, player, side, xHit, yHit);
+    }
+
+    private boolean isMiningBlock(final @NotNull TilePosc tilePos) {
+        return tilePos.equals(this.mining);
+    }
+
+    private void setMineBlock(final @Nullable TilePosc tilePos) {
+        this.mining = tilePos;
+    }
+
+    public void render(final float partialTick) {
+        final @NotNull HudIngame hud = Objects.requireNonNull(this.mc.hudIngame);
+        final @NotNull RenderGlobal renderGlobal = Objects.requireNonNull(this.mc.renderGlobal);
+
+        if (this.destroyProgress <= 0.0F) {
+            hud.destroyProgress = 0.0F;
+            renderGlobal.destroyProgress = 0.0F;
+        } else {
+            final float lDestroyProgress = this.oDestroyProgress + (this.destroyProgress - this.oDestroyProgress) * partialTick;
+            hud.destroyProgress = lDestroyProgress;
+            renderGlobal.destroyProgress = lDestroyProgress;
+        }
+
+        this.mc.ppm.render(partialTick);
+    }
+
+    public void tick() {
+        if (this.swingCooldown > 0) {
+            this.swingCooldown--;
+        }
+
+        this.syncCurrentPlayItem();
+        this.oDestroyProgress = this.destroyProgress;
+        this.mc.sndManager.tick();
+
+        this.mc.ppm.tick();
+    }
+
+    /**
+     * Used to dynamically use or place an ItemStack on any given tile.
+     * <p>
+     * (i.e. interacting with a chest while holding a block, defaulting to opening the chest when standing, vs. placing the block when crouched)
+     */
+    public boolean useOrPlaceItemStackOnTile(final @NotNull Player player, final @NotNull World world, final @Nullable ItemStack itemStack, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xPlaced, final double yPlaced) {
+        if (!player.getGamemode().canInteract()) {
+            return false;
+        }
+
+        final @NotNull Block<?> block = world.getBlockType(tilePos);
+
+        if (player.getHeldObject() == null) {
+            if (player.isSneaking() && itemStack == null) { // If crouched and hand empty try to pickup block entity
+                final @Nullable TileEntity tileEntity = world.getTileEntity(tilePos);
+                if (tileEntity != null && tileEntity.canBeCarried(world, player)) {
+                    player.setHeldObject(tileEntity.pickup(world, player));
+                    return true;
+                }
+            }
+            if (!player.isSneaking() || itemStack == null) {  // If standing or hand empty perform block right click method
+                if (block.onInteracted(world, tilePos, player, side, xPlaced, yPlaced)) {
+                    return true;
+                }
+            }
+            if (itemStack == null) { // No stack then do nothing
+                return false;
+            } else { // Use itemStack
+                return itemStack.useItemOnBlock(player, world, tilePos, side, xPlaced, yPlaced);
+            }
+        } else {
+            if (!player.isSneaking()) {  // If standing or hand empty perform block right click method
+                if (block.onInteracted(world, tilePos, player, side, xPlaced, yPlaced)) {
+                    return true;
+                }
+            }
+
+            if (player.getHeldObject().tryPlace(world, player, tilePos.x(), tilePos.y(), tilePos.z(), side, xPlaced, yPlaced)) {
+                player.setHeldObject(null);
+                return true;
+            }
+
+            return false;
+        }
+    }
+
+    /**
+     * Used to specifically use an ItemStack on nothing, most commonly defaulting to typical "item use" behavior.
+     * <p>
+     * (i.e. throwing a fishing rod or shooting a bow)
+     */
+    public boolean useItemStackOnNothing(final @NotNull Player player, final @NotNull World world, final @NotNull ItemStack stack) {
+        if (!player.getGamemode().canInteract()) {
+            return false;
+        }
+
+        final int prevStackSize = stack.stackSize;
+        final @Nullable ItemStack newItemStack = stack.useItem(world, player);
+        if (newItemStack != stack || newItemStack.stackSize != prevStackSize) {
+            player.inventory.setCurrentItem(newItemStack);
+            if (newItemStack == null || newItemStack.stackSize <= 0) {
+                player.inventory.setCurrentItem(null);
+            }
+
+            return true;
+        }
+
+        return false;
+    }
+
+    /**
+     * Used to exclusively place an ItemStack. No interactions, just placing a held ItemStack.
+     * <p>
+     * (i.e. placing blocks using easy bridge)
+     */
+    public boolean placeItemStackOnTile(final @NotNull Player player, final @NotNull World world, final @Nullable ItemStack itemStack, final @NotNull TilePosc tilePos, final @NotNull Side side, final double xPlaced, final double yPlaced) {
+        if (!player.getGamemode().canInteract()) {
+            return false;
+        }
+
+        if (player.getHeldObject() == null) {
+            if (itemStack == null) { // No stack then do nothing
+                return false;
+            } else { // Use itemStack
+                return itemStack.useItemOnBlock(player, world, tilePos, side, xPlaced, yPlaced);
+            }
+        }
+
+        return false;
+    }
+
+    public @NotNull Player createPlayer(final @NotNull World world) {
+        return new PlayerLocal(this.mc, world, Objects.requireNonNull(this.mc.session), Objects.requireNonNull(world.dimension).id);
+    }
+
+    public boolean interact(final @NotNull Player player, final @NotNull Entity entity) {
+        if (!player.getGamemode().canInteract()) {
+            return false;
+        }
+
+        return player.useCurrentItemOnEntity(entity);
+    }
+
+    public void attack(final @NotNull Player player, final @NotNull Entity entity) {
+        if (!player.getGamemode().canInteract()) {
+            return;
+        }
+
+        player.attackTargetEntityWithCurrentItem(entity);
+    }
+
+    public @Nullable ItemStack handleInventoryMouseClick(final int windowId, final @NotNull InventoryAction action, final int @Nullable [] args, final @NotNull Player player) {
+        return player.containerMenu.clicked(action, args, player);
+    }
+
+    public void handleCloseInventory(final int windowId, final @NotNull Player player) {
+        player.containerMenu.onCraftGuiClosed(player);
+        player.containerMenu = player.inventoryMenu;
+    }
+
+    public void playDigSound(final @NotNull Block<?> block, final @NotNull TilePosc tilePos) {
+        if (this.soundDelay <= 0) {
+            Objects.requireNonNull(this.mc.currentWorld).playBlockSoundEffect(null, tilePos.x() + 0.5f, tilePos.y() + 0.5f, tilePos.z() + 0.5f, block, EnumBlockSoundEffectType.DIG);
+            this.soundDelay = 3;
+        } else {
+            this.soundDelay--;
+        }
+    }
+
+    protected void syncCurrentPlayItem() {
+        // Do nothing
+    }
+
+    public void sendStartDigPacket(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+        // Do nothing
+    }
+
+    public void sendDestroyBlockPacket(final @NotNull TilePosc tilePos, final @NotNull Side side, final double xHit, final double yHit) {
+    }
+
+    public void setPaintingType(final @NotNull ArtType art) {
+        Objects.requireNonNull(this.mc.thePlayer).setSelectedArt(art);
+    }
 }
